// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from rc_common_msgs:msg/ReturnCode.idl
// generated code does not contain a copyright notice

#ifndef RC_COMMON_MSGS__MSG__DETAIL__RETURN_CODE__FUNCTIONS_H_
#define RC_COMMON_MSGS__MSG__DETAIL__RETURN_CODE__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "rc_common_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "rc_common_msgs/msg/detail/return_code__struct.h"

/// Initialize msg/ReturnCode message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * rc_common_msgs__msg__ReturnCode
 * )) before or use
 * rc_common_msgs__msg__ReturnCode__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_rc_common_msgs
bool
rc_common_msgs__msg__ReturnCode__init(rc_common_msgs__msg__ReturnCode * msg);

/// Finalize msg/ReturnCode message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rc_common_msgs
void
rc_common_msgs__msg__ReturnCode__fini(rc_common_msgs__msg__ReturnCode * msg);

/// Create msg/ReturnCode message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * rc_common_msgs__msg__ReturnCode__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_rc_common_msgs
rc_common_msgs__msg__ReturnCode *
rc_common_msgs__msg__ReturnCode__create();

/// Destroy msg/ReturnCode message.
/**
 * It calls
 * rc_common_msgs__msg__ReturnCode__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rc_common_msgs
void
rc_common_msgs__msg__ReturnCode__destroy(rc_common_msgs__msg__ReturnCode * msg);


/// Initialize array of msg/ReturnCode messages.
/**
 * It allocates the memory for the number of elements and calls
 * rc_common_msgs__msg__ReturnCode__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_rc_common_msgs
bool
rc_common_msgs__msg__ReturnCode__Sequence__init(rc_common_msgs__msg__ReturnCode__Sequence * array, size_t size);

/// Finalize array of msg/ReturnCode messages.
/**
 * It calls
 * rc_common_msgs__msg__ReturnCode__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rc_common_msgs
void
rc_common_msgs__msg__ReturnCode__Sequence__fini(rc_common_msgs__msg__ReturnCode__Sequence * array);

/// Create array of msg/ReturnCode messages.
/**
 * It allocates the memory for the array and calls
 * rc_common_msgs__msg__ReturnCode__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_rc_common_msgs
rc_common_msgs__msg__ReturnCode__Sequence *
rc_common_msgs__msg__ReturnCode__Sequence__create(size_t size);

/// Destroy array of msg/ReturnCode messages.
/**
 * It calls
 * rc_common_msgs__msg__ReturnCode__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rc_common_msgs
void
rc_common_msgs__msg__ReturnCode__Sequence__destroy(rc_common_msgs__msg__ReturnCode__Sequence * array);

#ifdef __cplusplus
}
#endif

#endif  // RC_COMMON_MSGS__MSG__DETAIL__RETURN_CODE__FUNCTIONS_H_
