// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rc_common_msgs:msg/CameraParam.idl
// generated code does not contain a copyright notice
#include "rc_common_msgs/msg/detail/camera_param__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `line_source`
// Member `extra_data`
#include "rc_common_msgs/msg/detail/key_value__functions.h"

bool
rc_common_msgs__msg__CameraParam__init(rc_common_msgs__msg__CameraParam * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    rc_common_msgs__msg__CameraParam__fini(msg);
    return false;
  }
  // is_color_camera
  // exposure_time
  // gain
  // line_status_all
  // line_source
  if (!rc_common_msgs__msg__KeyValue__Sequence__init(&msg->line_source, 0)) {
    rc_common_msgs__msg__CameraParam__fini(msg);
    return false;
  }
  // extra_data
  if (!rc_common_msgs__msg__KeyValue__Sequence__init(&msg->extra_data, 0)) {
    rc_common_msgs__msg__CameraParam__fini(msg);
    return false;
  }
  return true;
}

void
rc_common_msgs__msg__CameraParam__fini(rc_common_msgs__msg__CameraParam * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // is_color_camera
  // exposure_time
  // gain
  // line_status_all
  // line_source
  rc_common_msgs__msg__KeyValue__Sequence__fini(&msg->line_source);
  // extra_data
  rc_common_msgs__msg__KeyValue__Sequence__fini(&msg->extra_data);
}

rc_common_msgs__msg__CameraParam *
rc_common_msgs__msg__CameraParam__create()
{
  rc_common_msgs__msg__CameraParam * msg = (rc_common_msgs__msg__CameraParam *)malloc(sizeof(rc_common_msgs__msg__CameraParam));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rc_common_msgs__msg__CameraParam));
  bool success = rc_common_msgs__msg__CameraParam__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
rc_common_msgs__msg__CameraParam__destroy(rc_common_msgs__msg__CameraParam * msg)
{
  if (msg) {
    rc_common_msgs__msg__CameraParam__fini(msg);
  }
  free(msg);
}


bool
rc_common_msgs__msg__CameraParam__Sequence__init(rc_common_msgs__msg__CameraParam__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rc_common_msgs__msg__CameraParam * data = NULL;
  if (size) {
    data = (rc_common_msgs__msg__CameraParam *)calloc(size, sizeof(rc_common_msgs__msg__CameraParam));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rc_common_msgs__msg__CameraParam__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rc_common_msgs__msg__CameraParam__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rc_common_msgs__msg__CameraParam__Sequence__fini(rc_common_msgs__msg__CameraParam__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rc_common_msgs__msg__CameraParam__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rc_common_msgs__msg__CameraParam__Sequence *
rc_common_msgs__msg__CameraParam__Sequence__create(size_t size)
{
  rc_common_msgs__msg__CameraParam__Sequence * array = (rc_common_msgs__msg__CameraParam__Sequence *)malloc(sizeof(rc_common_msgs__msg__CameraParam__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = rc_common_msgs__msg__CameraParam__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
rc_common_msgs__msg__CameraParam__Sequence__destroy(rc_common_msgs__msg__CameraParam__Sequence * array)
{
  if (array) {
    rc_common_msgs__msg__CameraParam__Sequence__fini(array);
  }
  free(array);
}
